Package com.gpudb.protocol
Class MatchGraphRequest.Options
java.lang.Object
com.gpudb.protocol.MatchGraphRequest.Options
Enclosing class:
A set of string constants for the
MatchGraphRequest parameter options.
Additional parameters.
Field Summary
FieldsModifier and TypeFieldDescriptionstatic final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMARKOV_CHAINsolver only.static final StringFor theMATCH_CHARGING_STATIONSsolver only.static final StringFor theMATCH_CHARGING_STATIONSsolver only.static final StringFor theMATCH_CHARGING_STATIONSsolver only.static final StringFor theMATCH_CLUSTERSsolver only.static final StringWKT ending point fromsamplePointsfor the solver.static final StringFor theMATCH_ROUTE_DETOURsolver only.static final StringFor theMATCH_ROUTE_DETOURsolver only.static final StringFor theMATCH_ROUTE_DETOURsolver only.static final StringFor theMATCH_ROUTE_DETOURsolver only.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringApplies odd/even rule restrictions to even tagged vehicles.static final Stringstatic final StringFor theMARKOV_CHAINsolver only.static final StringFor theMATCH_PATTERNandMATCH_EMBEDDINGsolvers only.static final StringUses the Newman Girvan quality metric for cluster solver.static final StringGPS noise value (in meters) to remove redundant sample points.static final StringThis will add an additional weight over the edges labeled as ‘intersection’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation.static final StringFor theMATCH_BATCH_SOLVESsolver only.static final StringThis will add an additional weight over the edges labeled as ‘left turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SIMILARITYandMATCH_EMBEDDINGsolvers only.static final StringFor theMATCH_LOOPSsolver only.static final StringFor theMATCH_CLUSTERSandMATCH_EMBEDDINGsolvers only.static final StringFor theMARKOV_CHAINsolver only.static final StringFor theMATCH_ISOCHRONEsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDandMATCH_PICKUP_DROPOFFsolvers only.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_LOOPSsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringDoes not apply odd/even rule restrictions to any vehicles.static final StringFor theMATCH_CLUSTERSsolver only.static final StringFor theMATCH_CLUSTERSandMATCH_EMBEDDINGsolvers only.static final StringFor theMATCH_CLUSTERSsolver only.static final StringMaximum number of potentially matching road segments for each sample point.static final StringApplies odd/even rule restrictions to odd tagged vehicles.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_EMBEDDINGsolver only.static final StringFor theMATCH_EMBEDDINGsolvers only.static final StringFor theMATCH_LOOPSsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SIMILARITYsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringThis will add an additional weight over the edges labeled as’ right turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_LOOPSsolver only.static final StringMaximum search radius used when snapping sample points onto potentially matching surrounding segments.static final StringIndicates which graph server(s) to send the request to.static final StringFor theMATCH_SUPPLY_DEMANDsolver only.static final StringFor theMATCH_SUPPLY_DEMANDandMATCH_PICKUP_DROPOFFsolvers only.static final StringThis will add an additional weight over the edges labeled as ‘sharp turn’ or ‘u-turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation.static final StringWKT starting point fromsamplePointsfor the solver.static final StringApplies recursive spectral bisection (RSB) partitioning solver.static final StringFor theMATCH_SIMILARITYsolver only.static final Stringstatic final StringFor theMATCH_SUPPLY_DEMANDsolver only.
Field Details
NUM_SEGMENTS
Maximum number of potentially matching road segments for each sample point. For theMARKOV_CHAINsolver, the default is 3. The default value is ‘3’.See Also:CHAIN_WIDTH
For theMARKOV_CHAINsolver only. Length of the sample points lookahead window within the Markov kernel; the larger the number, the more accurate the solution. The default value is ‘9’.See Also:SOURCE
WKT starting point fromsamplePointsfor the solver. The default behavior for the endpoint is to use time to determine the starting point. The default value is ‘POINT NULL’.See Also:DESTINATION
WKT ending point fromsamplePointsfor the solver. The default behavior for the endpoint is to use time to determine the destination point. The default value is ‘POINT NULL’.See Also:PARTIAL_LOADING
For theMATCH_SUPPLY_DEMANDsolver only. When false (non-default), trucks do not off-load at the demand (store) side if the remainder is less than the store’s need. Supported values:TRUE: Partial off-loading at multiple store (demand) locations.FALSE: No partial off-loading allowed if supply is less than the store’s demand.
TRUE.See Also:MAX_COMBINATIONS
For theMATCH_SUPPLY_DEMANDsolver only. This is the cutoff for the number of generated combinations for sequencing the demand locations - can increase this up to 2M. The default value is ‘10000’.See Also:MAX_SUPPLY_COMBINATIONS
For theMATCH_SUPPLY_DEMANDsolver only. This is the cutoff for the number of generated combinations for sequencing the supply locations if/when ‘permute_supplies’ is true. The default value is ‘10000’.See Also:LEFT_TURN_PENALTY
This will add an additional weight over the edges labeled as ‘left turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation. The default value is ‘0.0’.See Also:RIGHT_TURN_PENALTY
This will add an additional weight over the edges labeled as’ right turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation. The default value is ‘0.0’.See Also:INTERSECTION_PENALTY
This will add an additional weight over the edges labeled as ‘intersection’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation. The default value is ‘0.0’.See Also:SHARP_TURN_PENALTY
This will add an additional weight over the edges labeled as ‘sharp turn’ or ‘u-turn’ if the ‘add_turn’ option parameter of theGPUdb.createGraphwas invoked at graph creation. The default value is ‘0.0’.See Also:AGGREGATED_OUTPUT
For theMATCH_SUPPLY_DEMANDsolver only. When it is true (default), each record in the output table shows a particular truck’s scheduled cumulative round trip path (MULTILINESTRING) and the corresponding aggregated cost. Otherwise, each record shows a single scheduled truck route (LINESTRING) towards a particular demand location (store id) with its corresponding cost. The default value is ‘true’.See Also:OUTPUT_TRACKS
For theMATCH_SUPPLY_DEMANDsolver only. When it is true (non-default), the output will be in tracks format for all the round trips of each truck in which the timestamps are populated directly from the edge weights starting from their originating depots. The default value is ‘false’.See Also:MAX_TRIP_COST
For theMATCH_SUPPLY_DEMANDandMATCH_PICKUP_DROPOFFsolvers only. If this constraint is greater than zero (default) then the trucks/rides will skip traveling from one demand/pick location to another if the cost between them is greater than this number (distance or time). Zero (default) value means no check is performed. The default value is ‘0.0’.See Also:FILTER_FOLDING_PATHS
For theMARKOV_CHAINsolver only. When true (non-default), the paths per sequence combination is checked for folding over patterns and can significantly increase the execution time depending on the chain width and the number of GPS samples. Supported values:The default value isFALSE.See Also:UNIT_UNLOADING_COST
For theMATCH_SUPPLY_DEMANDsolver only. The unit cost per load amount to be delivered. If this value is greater than zero (default) then the additional cost of this unit load multiplied by the total dropped load will be added over to the trip cost to the demand location. The default value is ‘0.0’.See Also:MAX_NUM_THREADS
For theMARKOV_CHAINsolver only. If specified (greater than zero), the maximum number of threads will not be greater than the specified value. It can be lower due to the memory and the number cores available. Default value of zero allows the algorithm to set the maximal number of threads within these constraints. The default value is ‘0’.See Also:SERVICE_LIMIT
For theMATCH_SUPPLY_DEMANDsolver only. If specified (greater than zero), any supply actor’s total service cost (distance or time) will be limited by the specified value including multiple rounds (if set). The default value is ‘0.0’.See Also:ENABLE_REUSE
For theMATCH_SUPPLY_DEMANDsolver only. If specified (true), all supply actors can be scheduled for second rounds from their originating depots. Supported values:TRUE: Allows reusing supply actors (trucks, e.g.) for scheduling again.FALSE: Supply actors are scheduled only once from their depots.
FALSE.See Also:MAX_STOPS
For theMATCH_SUPPLY_DEMANDsolver only. If specified (greater than zero), a supply actor (truck) can at most have this many stops (demand locations) in one round trip. Otherwise, it is unlimited. If ‘enable_truck_reuse’ is on, this condition will be applied separately at each round trip use of the same truck. The default value is ‘0’.See Also:SERVICE_RADIUS
For theMATCH_SUPPLY_DEMANDandMATCH_PICKUP_DROPOFFsolvers only. If specified (greater than zero), it filters the demands/picks outside this radius centered around the supply actor/ride’s originating location (distance or time). The default value is ‘0.0’.See Also:PERMUTE_SUPPLIES
For theMATCH_SUPPLY_DEMANDsolver only. If specified (true), supply side actors are permuted for the demand combinations during MSDO optimization - note that this option increases optimization time significantly - use of ‘max_combinations’ option is recommended to prevent prohibitively long runs. Supported values:TRUE: Generates sequences over supply side permutations if total supply is less than twice the total demand.FALSE: Permutations are not performed, rather a specific order of supplies based on capacity is computed.
TRUE.See Also:BATCH_TSM_MODE
For theMATCH_SUPPLY_DEMANDsolver only. When enabled, it sets the number of visits on each demand location by a single salesman at each trip is considered to be (one) 1, otherwise there is no bound. Supported values:TRUE: Sets only one visit per demand location by a salesman (TSM mode).FALSE: No preset limit (usual MSDO mode).
FALSE.See Also:ROUND_TRIP
For theMATCH_SUPPLY_DEMANDsolver only. When enabled, the supply will have to return back to the origination location. Supported values:TRUE: The optimization is done for trips in round trip manner always returning to originating locations.FALSE: Supplies do not have to come back to their originating locations in their routes. The routes are considered finished at the final dropoff.
TRUE.See Also:NUM_CYCLES
For theMATCH_CLUSTERSsolver only. Terminates the cluster exchange iterations across 2-step-cycles (outer loop) when quality does not improve during iterations. The default value is ‘10’.See Also:NUM_LOOPS_PER_CYCLE
For theMATCH_CLUSTERSandMATCH_EMBEDDINGsolvers only. Terminates the cluster exchanges within the first step iterations of a cycle (inner loop) unless convergence is reached. The default value is ‘10’.See Also:NUM_OUTPUT_CLUSTERS
For theMATCH_CLUSTERSsolver only. Limits the output to the top ‘num_output_clusters’ clusters based on density. Default value of zero outputs all clusters. The default value is ‘0’.See Also:MAX_NUM_CLUSTERS
For theMATCH_CLUSTERSandMATCH_EMBEDDINGsolvers only. If set (value greater than zero), it terminates when the number of clusters goes below than this number. For embedding solver the default is 8. The default value is ‘0’.See Also:CLUSTER_QUALITY_METRIC
For theMATCH_CLUSTERSsolver only. The quality metric for Louvain modularity optimization solver. Supported values:GIRVAN: Uses the Newman Girvan quality metric for cluster solver.SPECTRAL: Applies recursive spectral bisection (RSB) partitioning solver.
GIRVAN.See Also:RESTRICTED_TYPE
For theMATCH_SUPPLY_DEMANDsolver only. Optimization is performed by restricting routes labeled by ‘MSDO_ODDEVEN_RESTRICTED’ only for this supply actor (truck) type. Supported values:ODD: Applies odd/even rule restrictions to odd tagged vehicles.EVEN: Applies odd/even rule restrictions to even tagged vehicles.NONE: Does not apply odd/even rule restrictions to any vehicles.
NONE.See Also:INVERSE_SOLVE
For theMATCH_BATCH_SOLVESsolver only. Solves source-destination pairs using inverse shortest path solver. Supported values:The default value isFALSE.See Also:MIN_LOOP_LEVEL
For theMATCH_LOOPSsolver only. Finds closed loops around each node deducible not less than this minimal hop (level) deep. The default value is ‘0’.See Also:MAX_LOOP_LEVEL
For theMATCH_LOOPSsolver only. Finds closed loops around each node deducible not more than this maximal hop (level) deep. The default value is ‘5’.See Also:SEARCH_LIMIT
For theMATCH_LOOPSsolver only. Searches within this limit of nodes per vertex to detect loops. The value zero means there is no limit. The default value is ‘10000’.See Also:OUTPUT_BATCH_SIZE
For theMATCH_LOOPSsolver only. Uses this value as the batch size of the number of loops in flushing(inserting) to the output table. The default value is ‘1000’.See Also:CHARGING_CAPACITY
For theMATCH_CHARGING_STATIONSsolver only. This is the maximum ev-charging capacity of a vehicle (distance in meters or time in seconds depending on the unit of the graph weights). The default value is ‘300000.0’.See Also:CHARGING_CANDIDATES
For theMATCH_CHARGING_STATIONSsolver only. Solver searches for this many number of stations closest around each base charging location found by capacity. The default value is ‘10’.See Also:CHARGING_PENALTY
For theMATCH_CHARGING_STATIONSsolver only. This is the penalty for full charging. The default value is ‘30000.0’.See Also:DETOUR_MARK_COST
For theMATCH_ROUTE_DETOURsolver only. Cost along the route at which to search for nearby stations If zero, it solves along the trip sliding the 3 SSSP cycle kernel by radius amount. The default value is ‘3600.0’.See Also:DETOUR_REENTRY_FACTOR
For theMATCH_ROUTE_DETOURsolver only. Multiplier on detour_mark_cost to determine the reentry point on the route (default 1.2 means 20% further along). The default value is ‘1.2’.See Also:DETOUR_SEARCH_RADIUS
For theMATCH_ROUTE_DETOURsolver only. Search radius around the mark point for finding nearby prospective stations (e.g. cafes, pit stops, EV charging stations). The default value is ‘600.0’.See Also:DETOUR_SEARCH_LIMIT
For theMATCH_ROUTE_DETOURsolver only. Maximum number of nearby stations to consider within the search radius around the mark point. The default value is ‘10’.See Also:MAX_HOPS
For theMATCH_SIMILARITYandMATCH_EMBEDDINGsolvers only. Searches within this maximum hops for source and target node pairs to compute the Jaccard scores. The default value is ‘3’.See Also:TRAVERSAL_NODE_LIMIT
For theMATCH_SIMILARITYsolver only. Limits the traversal depth if it reaches this many number of nodes. The default value is ‘1000’.See Also:PAIRED_SIMILARITY
For theMATCH_SIMILARITYsolver only. If true, it computes Jaccard score between each pair, otherwise it will compute Jaccard from the intersection set between the source and target nodes. Supported values:The default value isTRUE.See Also:FORCE_UNDIRECTED
For theMATCH_PATTERNandMATCH_EMBEDDINGsolvers only. Pattern matching will be using both pattern and graph as undirected if set to true. Supported values:The default value isFALSE.See Also:MAX_VECTOR_DIMENSION
For theMATCH_EMBEDDINGsolver only. Limits the number of dimensions in node vector embeddings. The default value is ‘1000’.See Also:EMBEDDING_WEIGHTS
For theMATCH_EMBEDDINGsolver only. User specified weights per sub feature in vector embeddings. The string contains the comma separated float values for each sub-feature in the vector space. These values will ONLY be used if ‘optimize_embedding_weights’ is false. The default value is ‘1.0,1.0,1.0,1.0’.See Also:OPTIMIZATION_SAMPLING_SIZE
For theMATCH_EMBEDDINGsolver only. Sets the number of random nodes from the graph for solving the weights using stochastic gradient descent. The default value is ‘1000’.See Also:OPTIMIZATION_MAX_ITERATIONS
For theMATCH_EMBEDDINGsolver only. When the iterations (epochs) for the convergence of the stochastic gradient descent algorithm reaches this number it bails out unless relative error between consecutive iterations is below the ‘optimization_error_tolerance’ option. The default value is ‘1000’.See Also:OPTIMIZATION_ERROR_TOLERANCE
For theMATCH_EMBEDDINGsolver only. When the relative error between all of the weights’ consecutive iterations falls below this threshold the optimization cycle is interrupted unless the number of iterations reaches the limit set by the option ‘max_optimization_iterations’. The default value is ‘0.001’.See Also:OPTIMIZATION_ITERATION_RATE
For theMATCH_EMBEDDINGsolver only. It is otherwise known as the learning rate, which is the proportionality constant in front of the gradient term in successive iterations. The default value is ‘0.3’.See Also:MAX_RADIUS
For theMATCH_ISOCHRONEsolver only. Sets the maximal reachability limit for computing isochrones. Zero means no limit. The default value is ‘0.0’.See Also: